// SPDX-FileCopyrightText: 2024 Yury Gubich <blue@macaw.me>
// SPDX-License-Identifier: GPL-3.0-or-later

#pragma once

#include <string>
#include <memory>
#include <functional>

#include <gloox/client.h>
#include <gloox/messagehandler.h>
#include <gloox/message.h>

#include "component/config.h"

class Message : public gloox::MessageHandler {
private:
    typedef std::function<void (const std::string&, const std::string&)> Callback;

public:
    Message(const std::shared_ptr<Config>& config, const std::shared_ptr<gloox::Client>& client, const Callback& callback);
    ~Message();

    void handleMessage(const gloox::Message& message, gloox::MessageSession* session = 0) override;

private:
    Callback callback;
    std::weak_ptr<Config> config;
    std::weak_ptr<gloox::Client> client;
};
